#include <sourcemod>
#include <sdktools>
#include <multicolors>
#include <cstrike>
#include <autoexecconfig>

#define DEBUG

#pragma semicolon 1

#pragma newdecls required

//BOOL
bool InCooldown = false;

//CONVARS
char g_ChatPrefix[256];
ConVar gConVar_Chat_Prefix;

ConVar gConVar_Cooldown;
ConVar gConVar_Scramble;
ConVar gConVar_CooldownTime;

//INT
int yes;
int no;

public Plugin myinfo = 
{
	name = "Surrender", 
	author = "Lantejoula", 
	description = "Allows a team to surrender", 
	version = "1.0", 
	url = "https://steamcommunity.com/id/lantejoula"
};

//PLUGIN START

public void OnPluginStart()
{
	//TRANSLATIONS
	LoadTranslations("surrender.phrases");
	
	//COMMAND
	
	RegConsoleCmd("sm_surrender", Command_Surrender);
	RegConsoleCmd("sm_gg", Command_Surrender);
	
	//CONVARS
	
	AutoExecConfig_SetFile("plugin.surrender");
	
	gConVar_Chat_Prefix = AutoExecConfig_CreateConVar("sm_surrender_chat_prefix", "{green}[TAG]{default}", "Chat Prefix");
	
	gConVar_Cooldown = AutoExecConfig_CreateConVar("sm_surrender_cooldown", "1", "Enable/Disable the Cooldown System (1 - Enable | 0 - Disable)", 0, true, 0.0, true, 1.0);
	
	gConVar_Scramble = AutoExecConfig_CreateConVar("sm_surrender_scramble", "1", "Enable/Disable the Scrable Teams when Someone Surrender (1 - Enable | 0 - Disable)", 0, true, 0.0, true, 1.0);
	
	gConVar_CooldownTime = AutoExecConfig_CreateConVar("sm_surrender_cooldown_time", "600", "How many time command have cooldown? ( Default 600 = 10 Min)", 0, true, 30.0, true, 3600.0);
	
	AutoExecConfig_ExecuteFile();
	AutoExecConfig_CleanFile();
	
	gConVar_Chat_Prefix.AddChangeHook(OnPrefixChange);
}

//PREFIX

public void SavePrefix()
{
	GetConVarString(gConVar_Chat_Prefix, g_ChatPrefix, sizeof(g_ChatPrefix));
}

public void OnConfigsExecuted()
{
	SavePrefix();
}

public void OnPrefixChange(ConVar cvar, char[] oldvalue, char[] newvalue)
{
	SavePrefix();
}

//MAP START

public void OnMapStart()
{
	if (gConVar_Cooldown.BoolValue)
	{
		CreateTimer(gConVar_CooldownTime.FloatValue, Cooldown); // 600 second cooldown (10 min)
		
		InCooldown = true;
	}
}

//SURRENDER COMMAND

public Action Command_Surrender(int client, int args)
{
	if (gConVar_Cooldown.BoolValue)
	{
		if (InCooldown)
		{
			CPrintToChat(client, "%s %t", g_ChatPrefix, "SurrenderInCooldown");
			return Plugin_Handled;
		}
		else if (!InCooldown)
		{
			CreateTimer(gConVar_CooldownTime.FloatValue, Cooldown); // 600 second cooldown (10 min)
			
			InCooldown = true;
		}
	}
	
	if (GetClientTeam(client) != CS_TEAM_T && GetClientTeam(client) != CS_TEAM_CT)
	{
		CPrintToChat(client, "%s %t", g_ChatPrefix, "JoinValidTeam");
	}
	
	if (GetClientTeam(client) == CS_TEAM_T)
	{
		for (int i = 1; i <= MaxClients; i++)
		{
			if (IsValidClient(i))
			{
				if (GetClientTeam(i) == CS_TEAM_T)
				{
					OpenSurrenderMenuT(i);
				}
			}
		}
		
		CPrintToChatAll("%s %t", g_ChatPrefix, "TeamTIsSurrender");
	}
	
	if (GetClientTeam(client) == CS_TEAM_CT)
	{
		for (int i = 1; i <= MaxClients; i++)
		{
			if (IsValidClient(i))
			{
				if (GetClientTeam(i) == CS_TEAM_CT)
				{
					OpenSurrenderMenuCT(i);
				}
			}
		}
		
		CPrintToChatAll("%s %t", g_ChatPrefix, "TeamCTIsSurrender");
	}
	
	return Plugin_Handled;
}

//TIMER COOLDOWN

public Action Cooldown(Handle timer)
{
	InCooldown = false;
}

//MENU T

public void OpenSurrenderMenuT(int client)
{
	char Yes[128];
	char No[128];
	
	Menu menu = new Menu(MenuSurrenderT);
	menu.SetTitle("%t", "MenuSurrenderTitle");
	
	Format(Yes, sizeof(Yes), "%t", "YES");
	menu.AddItem("yes", Yes);
	
	Format(No, sizeof(No), "%t", "NO");
	menu.AddItem("no", No);
	
	menu.Display(client, MENU_TIME_FOREVER);
	
	CreateTimer(10.0, tTimerCountVotesT);
}

public int MenuSurrenderT(Menu menu, MenuAction action, int client, int args)
{
	if (action == MenuAction_Select)
	{
		char selectedItem[200];
		menu.GetItem(args, selectedItem, sizeof(selectedItem));
		
		if (StrEqual(selectedItem, "yes"))
		{
			yes++;
		}
		else
		{
			no++;
		}
	}
	else if (action == MenuAction_End)
	{
		delete menu;
	}
}

public Action tTimerCountVotesT(Handle timer)
{
	if (yes > no)
	{
		CPrintToChatAll("%s %t", g_ChatPrefix, "SurrenderedT");
		CS_TerminateRound(2.0, CSRoundEnd_Draw);
		CreateTimer(2.0, RestartGame1);
		
		if (gConVar_Scramble.BoolValue)
			CreateTimer(3.0, Scramble);
	}
	else
	{
		CPrintToChatAll("%s %t", g_ChatPrefix, "TeamVoteWasNoT");
	}
	
	yes = 0;
	no = 0;
}


//MENU CT

public void OpenSurrenderMenuCT(int client)
{
	char Yes[128];
	char No[128];
	
	Menu menu = new Menu(MenuSurrenderCT);
	menu.SetTitle("%t", "MenuSurrenderTitle");
	
	Format(Yes, sizeof(Yes), "%t", "YES");
	menu.AddItem("yes", Yes);
	
	Format(No, sizeof(No), "%t", "NO");
	menu.AddItem("no", No);
	
	menu.Display(client, MENU_TIME_FOREVER);
	
	CreateTimer(10.0, tTimerCountVotesCT);
}

public int MenuSurrenderCT(Menu menu, MenuAction action, int client, int args)
{
	if (action == MenuAction_Select)
	{
		char selectedItem[200];
		menu.GetItem(args, selectedItem, sizeof(selectedItem));
		
		if (StrEqual(selectedItem, "yes"))
		{
			yes++;
		}
		else
		{
			no++;
		}
	}
	else if (action == MenuAction_End)
	{
		delete menu;
	}
}

public Action tTimerCountVotesCT(Handle timer)
{
	if (yes > no)
	{
		CPrintToChatAll("%s %t", g_ChatPrefix, "SurrenderedCT");
		CS_TerminateRound(0.0, CSRoundEnd_Draw);
		CreateTimer(2.0, RestartGame1);
		
		if (gConVar_Scramble.BoolValue)
			CreateTimer(3.0, Scramble);
	}
	else
	{
		CPrintToChatAll("%s %t", g_ChatPrefix, "TeamVoteWasNoCT");
	}
	
	yes = 0;
	no = 0;
}

//TIMER SCRAMBLE

public Action Scramble(Handle timer, int client)
{
	Command_Scramble(client, 0);
}

//RESTART GAME

public Action RestartGame1(Handle timer, int client)
{
	ServerCommand("mp_restartgame 1");
}

//TEAM SCRAMBLE https://forums.alliedmods.net/showpost.php?p=2532995&postcount=2

public Action Command_Scramble(int client, int args)
{
	int iTotalPlayers = GetTeamClientCount(CS_TEAM_T) + GetTeamClientCount(CS_TEAM_CT);
	
	if (iTotalPlayers < 2 || GetTeamClientCount(CS_TEAM_T) == 0 || GetTeamClientCount(CS_TEAM_CT) == 0)
	{
		PrintToChatAll("%s %t", g_ChatPrefix, "Not enough players");
		return Plugin_Handled;
	}
	else
	{
		PrintToChatAll("%s %t", g_ChatPrefix, "Both teams was scrambled");
	}
	
	int iPlayersToMove = GetRandomInt(RoundToCeil(float(iTotalPlayers / 2)), iTotalPlayers - 1);
	
	if (iTotalPlayers == 2)
	{
		iPlayersToMove = 2;
	}
	
	for (int i = 1; i <= iPlayersToMove; i++)
	{
		if (i % 2 == 0)
		{
			int iTarget = GetRandomPlayer(CS_TEAM_CT);
			
			if (iTarget != -1)
			{
				CS_SwitchTeam(iTarget, CS_TEAM_T);
			}
		}
		else
		{
			int iTarget = GetRandomPlayer(CS_TEAM_T);
			
			if (iTarget != -1)
			{
				CS_SwitchTeam(iTarget, CS_TEAM_CT);
			}
		}
	}
	
	return Plugin_Handled;
}

stock int GetRandomPlayer(int team)
{
	int[] clients = new int[MaxClients];
	
	int clientCount;
	
	for (int i = 1; i <= MaxClients; i++)
	{
		if (IsClientInGame(i) && GetClientTeam(i) == team)
		{
			clients[clientCount++] = i;
		}
	}
	
	return (clientCount == 0) ? -1 : clients[GetRandomInt(0, clientCount - 1)];
}

//ISVALIDCLIENT

stock bool IsValidClient(int client)
{
	return (1 <= client <= MaxClients && IsClientInGame(client) && IsClientConnected(client) && !IsClientSourceTV(client) && !IsFakeClient(client));
} 